unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, VirtualTrees;

type
  TKeywordClass = class
   Name : string;
   Lang : string;
   Freq : Integer;
   Occur : Integer;
  end;

type
  TForm1 = class(TForm)
    VirtualStringTree1: TVirtualDrawTree;
    procedure FormCreate(Sender: TObject);
    procedure VirtualStringTree1DrawNode(Sender: TBaseVirtualTree;
      const PaintInfo: TVTPaintInfo);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  newKeyword : TKeywordClass;
  newNode : PVirtualNode;
  i:Integer;
begin
     VirtualStringTree1.NodeDataSize:= Sizeof(TObject);
     VirtualStringTree1.TreeOptions.MiscOptions :=  VirtualStringTree1.TreeOptions.MiscOptions + [toCheckSupport];
     VirtualStringTree1.CheckImageKind := ckXP;
     for i:=0 to 100 do
     begin
          newKeyword := TKeywordClass.Create;
          newKeyword.Name := 'Name' + IntToStr(i);
          newKeyword.Lang := 'Lang'+ IntToStr(i);
          newKeyword.Freq := i;
          newKeyword.Occur := 10;
          newNode :=  VirtualStringTree1.AddChild(nil,newKeyword);
          newNode.CheckType := ctCheckBox;
          newNode.CheckState := csCheckedNormal;
     end;
end;

procedure TForm1.VirtualStringTree1DrawNode(Sender: TBaseVirtualTree;
  const PaintInfo: TVTPaintInfo);
var
  KeyWord : ^TKeywordClass;
begin
  KeyWord := Sender.GetNodeData(PaintInfo.node);
  case PaintInfo.Column of
       1: PaintInfo.Canvas.TextOut(PaintInfo.CellRect.Left ,PaintInfo.CellRect.Top ,KeyWord.Name);
       2: PaintInfo.Canvas.TextOut(PaintInfo.CellRect.Left ,PaintInfo.CellRect.Top ,KeyWord.Lang );
       3: PaintInfo.Canvas.TextOut(PaintInfo.CellRect.Left ,PaintInfo.CellRect.Top ,IntToStr(KeyWord.Freq ));
       4: PaintInfo.Canvas.TextOut(PaintInfo.CellRect.Left ,PaintInfo.CellRect.Top ,IntToStr(KeyWord.Occur ));

  end;
end;

end.
